/*****************************************************************************/
/*                                                                           */
/* FILENAME                                                                  */
/* 	 main.c                                                                  */
/*                                                                           */
/* DESCRIPTION                                                               */
/*   TMS320C5515 USB Stick Application 20 Spectrum Analyser.                 */
/*   Take microphone input and send to headphones with ring modulation.      */
/*                                                                           */
/* REVISION                                                                  */
/*   Revision: 1.00	                                                         */
/*   Author  : Richard Sikora                                                */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* HISTORY                                                                   */
/*   Revision: 1.00                                                          */
/*   15th September 2010. Created from TMS320C5505 USB Stick code.           */
/*                                                                           */
/*****************************************************************************/
/*
 * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include "stdio.h"
#include "usbstk5515.h"
#include "usbstk5515_led.h"
#include "aic3204.h"
#include "PLL.h"
#include "oled.h"
#include "pushbuttons.h"
#include "stereo.h"
#include "dsplib.h"

Int16 left_input;
Int16 right_input;
Int16 left_output;
Int16 right_output;

short int faza1 = 0, deltaPhi1 = 0;
short int faza2 = 0, deltaPhi2 = 0;
int f1 = 2000, f2 = 5000;

int F1, F2; //Unormowane Częstotliwości cyfrowe
int fp;

short int sinus1, sinus2;


#define SAMPLES_PER_SECOND 48000
#define GAIN_IN_dB 0

//unsigned long int i = 0;

unsigned int Step = 0; 
unsigned int LastStep = 99;

char *napis1 = "1                   ";
char *napis2 = "2                   ";
 
/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void ) 
{
    /* Initialize BSL */
    USBSTK5515_init( );
	
	/* Initialize PLL */
	pll_frequency_setup(120);

    /* Initialise hardware interface and I2C for code */
    aic3204_hardware_init();
    
    /* Initialise the AIC3204 codec */
	aic3204_init(); 
	
	/* Turn off the 4 coloured LEDs */
	USBSTK5515_ULED_init();
	
	/* Initialise the OLED LCD display */
	oled_init();
	SAR_init();
	/* Flush display buffer */
    oled_display_message("                 ", "                   ");
    
    printf("\n\nĆwiczenie 1.1\n");
    printf( "Generator funkcyjny\n\n" );

	/* Setup sampling frequency and  gain for microphone */
    set_sampling_frequency_and_gain(SAMPLES_PER_SECOND, GAIN_IN_dB);

    oled_display_message("cwiczenie 1        ", "genrator funkcyjny ");

	/* New. Add descriptive text */ 
    puts(" 1 - generator sinusoidalny");
    puts(" 2 - generator przebiegu piłokształtnego");
    puts(" 3 - generator przebiegu trójkątnego");
    puts(" 4 - generator przebiegu prostokątnego");
    puts(" 5 - zmiana częstotliwości próbkowania sygnałów\n");

      
	/* Default to XF LED off */
	asm(" bclr XF");
	
    F1 = ((long)f1 * 22370 ) >> 14; 
    F2 = ((long)f2 * 22370 ) >> 14;
    
 	for ( ;; )
 	{

     aic3204_codec_read(&left_input, &right_input); // Configured for one interrupt per two channels.
   
     //F1 = ((long)f1 * 22370 ) >> 14; 
     faza1 += F1;
     sine(&faza1, &sinus1, 1);
     
     //F2 = ((long)f2 * 22370 ) >> 14;
     faza2 += F2;
     sine(&faza2, &sinus2, 1);
     
     Step = pushbuttons_read(5);
         
	  if ( Step == 1 )
        {
         if ( Step != LastStep )
          {
          	sprintf(napis1, "sin %5d Hz        ", f1);
          	sprintf(napis2, "sin %5d Hz        ", f2);
            oled_display_message(napis1, napis2);
            puts(" 1 - generator sinusoidalny");
            printf("Częstotliwość kanału lewego  fl = %d [Hz]\n", f1);
            printf("Częstotliwość kanału prawego fp = %d [Hz]\n", f2);          
           LastStep = Step;
          }	
         left_output = sinus1;      // Straight trough. No processing.
	     right_output = sinus2;

	    } 
	  if ( Step == 2)
        {
         if ( Step != LastStep )
          {
           	sprintf(napis1, "pila %5d Hz       ", f1);
          	sprintf(napis2, "pila %5d Hz       ", f2);
            oled_display_message(napis1, napis2);
            puts(" 2 - generator przebiegu piłokształtnego");
           	LastStep = Step;
          }	
         left_output = faza1;      // Straight trough. No processing.
	     right_output = faza2;

	    } 
      if ( Step == 3)
        {
         if ( Step != LastStep )
          {
           	sprintf(napis1, "trojkat %5d Hz    ", f1);
          	sprintf(napis2, "trojkat %5d Hz    ", f2);
            oled_display_message(napis1, napis2);
            puts(" 3 - generator przebiegu trójkątnego");
           	LastStep = Step;
          }	
         left_output  = _sshl(_abss(faza1) - (1<<14), 1);      // Straight trough. No processing.
	     right_output = _sshl(_abss(faza2) - (1<<14), 1); 

	    } 
	    if ( Step == 4)
        {
         if ( Step != LastStep )
          {
           	sprintf(napis1, "prostokat %5d Hz  ", f1);
          	sprintf(napis2, "prostokat %5d Hz  ", f2);
            oled_display_message(napis1, napis2);
            puts(" 4 - generator przebiegu prostokątnego");
           	LastStep = Step;
          }	
         if(faza1 >= 0) left_output = 25000; else left_output = -25000;     // Straight trough. No processing.
	     if(faza2 >= 0) right_output = 25000; else right_output = -25000; 

	    } 
	    if ( Step == 5)
        {
          if ( Step != LastStep )
          {	 
            oled_display_message("patrz na konsole  ", "i wpisz fo dla VCO");
            printf("Podaj częstotliwość kanału lewego [Hz] fl = ");
    		scanf("%d", &f1);
    		printf("Podaj częstotliwość kanału prawego [Hz] fp = ");
    		scanf("%d", &f2);
    		printf("Wybierz częstotliwość próbkowania \n1 ->  8 kHz\n2 -> 48 kHz ");
    		scanf("%d", &fp);
    		
    		if(fp == 2)
    		{
    		set_sampling_frequency_and_gain(48000, GAIN_IN_dB);
    		F1 = ((long)f1 * 22370 ) >> 14; 
     		F2 = ((long)f2 * 22370 ) >> 14;
    		}
     		
     		if(fp == 1)
    		{
     		set_sampling_frequency_and_gain(8000, GAIN_IN_dB);
     		F1 = ((long)f1 * 16777 ) >> 11; 
     		F2 = ((long)f2 * 16777 ) >> 11;
    		}
    		    
            LastStep = Step;
          }         
         left_output = sinus1;      // Straight trough. No processing.
	     right_output = sinus2;
	    }  
	    	  	    
     aic3204_codec_write(left_output, right_output);

 	}

   /* Disable I2S and put codec into reset */ 
    aic3204_disable();

    printf( "\n***Program has Terminated***\n" );
    
    oled_display_message("PROGRAM HAS        ", "TERMINATED        ");
    
    SW_BREAKPOINT;
}

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  End of main.c                                                           *
 *                                                                          *
 * ------------------------------------------------------------------------ */
